﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;
using System.IO;
using System.Threading;
using System.Diagnostics;
namespace MySqlBackUp
{
    public partial class Form1 : Form
    {

        private static string host = "localhost";
        private static string characterSet = "utf8";
        private static string port = "3306";
        private static string user = "root";
        private static string password = "sa";
        private static string databaseName = "";
        string SavePath = "D:\\MysqlBackup";
        //获取mysql.exe,mysqldump.exe所在路径
        String appDirecroty = System.Windows.Forms.Application.StartupPath + "\\";

        string filePath = ""; //备份时生成的文件夹路径
        bool boolBackdata;   //是否备份数据;
        private int counter = 0; //备份时的计数
        private int totlecount = 0; //备份的总数
        object lockobject = new object(); //备份时的lock对象
        object lockStoreobject = new object();//还原时的lock对象
        private int storecounter = 0; //还原时的计数
        private int storetotlecount = 0; //还原的总数

        public Form1()
        {
            InitializeComponent();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            btnBackStruct.Enabled = false;
            btnBackup.Enabled = false;
            txtcharacterSet.Text = Properties.Settings.Default.characterSet;
            txthost.Text = Properties.Settings.Default.host;
            txtpassword.Text = Properties.Settings.Default.password;
            txtport.Text = Properties.Settings.Default.port;
            txtuser.Text = Properties.Settings.Default.user;
            txtAppDirc.Text = appDirecroty;
            txtSavePath.Text = Properties.Settings.Default.savePath;
        }

        private void btnBackup_Click(object sender, EventArgs e)
        {
            CallBackUP(true);

        }

        private void btnBrowseAppDic_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                appDirecroty = folderBrowserDialog1.SelectedPath;
                txtAppDirc.Text = appDirecroty;
            }
        }

        private void btnBrowseSavepath_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                SavePath = folderBrowserDialog1.SelectedPath;
                txtSavePath.Text = SavePath;
            }
        }

        private void btnCon_Click(object sender, EventArgs e)
        {
            characterSet = txtcharacterSet.Text.Trim();
            databaseName = cmbDBlist.Text.Trim();
            host = txthost.Text.Trim();
            password = txtpassword.Text;
            port = txtport.Text.Trim();
            user = txtuser.Text.Trim();
            string constr = String.Format("server={0};uid={1}; Port={2};pwd={3}; database=mysql; pooling=false", host, user, port, password);
            try
            {
                DbObject dbhelper = new DbObject(constr);
                List<string> dblist = dbhelper.GetDBList();
                this.cmbDBlist.Enabled = true;
                btnBackup.Enabled = true;
                btnBackStruct.Enabled = true;
                this.cmbDBlist.Items.Clear();
                this.cmbDBlist.Items.Add("全部库(除系统库)");
                if (dblist != null)
                {
                    if (dblist.Count > 0)
                    {
                        foreach (string dbname in dblist)
                        {
                            if (dbname != "information_schema" && dbname != "mysql" && dbname != "performance_schema" && dbname != "test")
                                this.cmbDBlist.Items.Add(dbname);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnRestore_Click(object sender, EventArgs e)
        {
            //string s = "mysql --port=端口号 --user=用户名 --password=密码 数据库名<还原文件所在路径";
            OpenFileDialog openFileDialog = new OpenFileDialog();

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                clearTime();
                timer1.Enabled = true;
                DialogResult result = MessageBox.Show("您是否真的想覆盖以前的数据库吗？那么以前的数据库数据将丢失！！！", "警告", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
                if (result == DialogResult.Yes)
                {
                    List<string> files = new List<string>();
                    files.Add(openFileDialog.FileName);
                    BackgroundWorker backgroundStore = new BackgroundWorker();
                    backgroundStore.DoWork += new DoWorkEventHandler(backgroundStore_DoWork);
                    backgroundStore.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundStore_RunWorkerCompleted);
                    backgroundStore.RunWorkerAsync(files);
                }
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            textResult.Text = "";
        }

        private void btnBackStruct_Click(object sender, EventArgs e)
        {
            CallBackUP(false);
        }

        private void btnStoreMult_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                DialogResult result = MessageBox.Show("您是否真的想覆盖以前的数据库吗？那么以前的数据库数据将丢失！！！", "警告", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
                clearTime();
                timer1.Enabled = true;
                if (result == DialogResult.Yes)
                {
                    String directory = folderBrowserDialog1.SelectedPath;
                    System.IO.DirectoryInfo dirInfo = new System.IO.DirectoryInfo(directory);
                    System.IO.FileInfo[] files = dirInfo.GetFiles();
                    List<string> listfiles = new List<string>();
                    foreach (FileInfo fl in files)
                    {
                        listfiles.Add(fl.FullName);
                    }
                    storetotlecount = listfiles.Count;
                    storecounter = 0;
                    for (int i = 0; i < 4; i++)
                    {
                        BackgroundWorker backgroundStore = new BackgroundWorker();
                        backgroundStore.DoWork += new DoWorkEventHandler(backgroundStore_DoWork);
                        backgroundStore.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundStore_RunWorkerCompleted);
                        backgroundStore.RunWorkerAsync(listfiles);
                    }
                }
            }
        }


        private void backgroundWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            List<string> names = e.Argument as List<string>;
            BackupMany(filePath, names, boolBackdata);
            // List<object> list =e.Argument as List<object>;
            // List<string> names = list[1] as List<string>;
            // BackupMany(filePath, names, boolBackdata,list[0].ToString());
            e.Result = e.Argument.ToString();

        }


        private void backgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {

            // writeText(textResult,true,"完成数据库"+e.Result.ToString()+"备份操作" + Environment.NewLine);

        }


        private void backgroundStore_DoWork(object sender, DoWorkEventArgs e)
        {
            List<string> files = e.Argument as List<string>;
            StoreByThead(files);
        }

        private void backgroundStore_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {

        }

        delegate void WriteText(TextBox textbox, bool append, string text);
        private void writeText(TextBox textbox, bool append, string msg)
        {
            if (this.InvokeRequired)
            {
                WriteText d = new WriteText(writeText);
                object[] obj = new object[3];
                obj[0] = textbox;
                obj[1] = append;
                obj[2] = msg;
                this.Invoke(d, obj);
            }
            else
            {
                if (append)
                    textbox.AppendText(msg);
                else
                    textbox.Text = msg;
            }
        }


        private void CallBackUP(bool backupdata)
        {
            characterSet = txtcharacterSet.Text.Trim();
            databaseName = cmbDBlist.Text.Trim();
            host = txthost.Text.Trim();
            password = txtpassword.Text;
            port = txtport.Text.Trim();
            user = txtuser.Text.Trim();
            if (databaseName == "")
            {
                MessageBox.Show("请选择数据库");
                return;
            }
            String fileName = (databaseName + "-" + DateTime.Now.ToString()).Replace("-", "").Replace(":", "").Replace(" ", "").Replace("\\", "").Replace("/", "");
            string path;
            if (backupdata)
                path = SavePath + "\\结构和数据\\" + fileName;
            else
                path = SavePath + "\\" + "仅结构\\" + fileName;
            if (!System.IO.Directory.Exists(path))
            {
                System.IO.Directory.CreateDirectory(path);
            }
            filePath = path;
            boolBackdata = backupdata;
            List<string> remainDbNames = new List<string>();
            clearTime();
            timer1.Enabled = true;
            if (databaseName != "全部库(除系统库)")
            {
                totlecount = 1;
                counter = 0;
                remainDbNames.Clear();
                remainDbNames.Add(databaseName);
                BackgroundWorker backgroundWorker = new BackgroundWorker();
                backgroundWorker.DoWork += new DoWorkEventHandler(backgroundWorker_DoWork);
                backgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundWorker_RunWorkerCompleted);
                backgroundWorker.RunWorkerAsync(remainDbNames);
            }
            else
            {
                totlecount = cmbDBlist.Items.Count - 1;
                counter = 0;
                remainDbNames.Clear();
                for (int i = 1; i < cmbDBlist.Items.Count; i++)
                {
                    remainDbNames.Add(cmbDBlist.Items[i].ToString());
                }
                for (int i = 0; i < 8; i++)
                {
                    BackgroundWorker backgroundWorker = new BackgroundWorker();
                    backgroundWorker.DoWork += new DoWorkEventHandler(backgroundWorker_DoWork);
                    backgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundWorker_RunWorkerCompleted);
                    backgroundWorker.RunWorkerAsync(remainDbNames);
                    //List<object> objs = new List<object>();
                    //objs.Add("线程" + (i + 1));
                    //objs.Add(remainDbNames);
                    //backgroundWorker.RunWorkerAsync(objs);

                }
            }

        }

        private void Backup(string path, string databaseName, bool backupdata)
        {
            try
            {
                writeText(textResult, true, DateTime.Now.ToString() + " 开始数据库" + databaseName + "备份" + Environment.NewLine);
                //String command = "mysqldump --quick --host=localhost --default-character-set=gb2312 --lock-tables --verbose  --force --port=端口号 --user=用户名 --password=密码 数据库名 -r 备份到的地址";
                //构建执行的命令
                String directory = path + "\\" + databaseName + ".sql";
                String command;
                if (backupdata)
                {
                    command = string.Format("mysqldump --quick --host={1} --default-character-set={2}  --lock-tables --routines --force --port={3} --user={4} --password={5} {6} -r \"{0}\"",
                            directory, host, characterSet, port, user, password, databaseName);
                }
                else
                {
                    command = string.Format("mysqldump --quick --host={1} --default-character-set={2} -d --lock-tables  --routines --force --port={3} --user={4} --password={5} {6} -r \"{0}\"",
                         directory, host, characterSet, port, user, password, databaseName);
                }
                Cmd.StartCmd(appDirecroty, command);
                writeText(textResult, true, DateTime.Now.ToString() + @" 数据库已成功备份到 " + directory + " 文件中" + Environment.NewLine);
                counter++;
                writeText(textBox1, false, "共" + totlecount + "个文件,已完成" + counter + "个文件");
            }
            catch (Exception ex)
            {
                writeText(txtErr, true, DateTime.Now.ToString() + " 数据库" + databaseName + "备份失败！");
            }
        }


        private void BackupMany(string path, List<string> dbNames, bool backupdata)
        {
            string name = null;
            lock (lockobject)
            {
                if (dbNames.Count > 0)
                {
                    name = dbNames[0];
                    dbNames.RemoveAt(0);
                }
            }
            if (name != null)
            {
                Backup(path, name, backupdata);
                BackupMany(path, dbNames, backupdata);
            }
            else
            {
                timer1.Enabled = false;
                writeText(textResult, true, "全部执行完成!");
            }

        }


        private void Store(string filepath)
        {
            string storeName = "";
            try
            {
                int tmp = filepath.LastIndexOf('\\');
                storeName = filepath.Substring(tmp + 1).TrimEnd(new char[] { '.', 's', 'q', 'l' });
                writeText(textResult, true, DateTime.Now.ToString() + " 开始还原数据库" + storeName + Environment.NewLine);
                string[] cmds = new string[2];
                cmds[0] = string.Format("mysql --host={0} --default-character-set={1} --port={2} --user={3} --password={4} --execute=\"create database  if not exists {5};\"", host, characterSet, port, user, password, storeName);
                //在文件路径后面加上""避免空格出现异常
                cmds[1] = string.Format("mysql --host={0} --default-character-set={1} --port={2} --user={3} --password={4} {5}<\"{6}\"", host, characterSet, port, user, password, storeName, filepath);
                Cmd.StartCmd(appDirecroty, cmds);
                writeText(textResult, true, DateTime.Now.ToString() + " 还原数据库" + storeName + "完成" + Environment.NewLine);
                storecounter++;
                writeText(textBox1, false, "共" + storetotlecount + "个文件,已完成" + storecounter + "个文件");
            }
            catch (Exception ex)
            {
                writeText(txtErr, true, DateTime.Now.ToString() + " 还原数据库" + storeName + "失败" + Environment.NewLine);
            }
        }


        private void StoreByThead(List<string> files)
        {
            string file = null;
            lock (lockStoreobject)
            {
                if (files.Count > 0)
                {
                    file = files[0];
                    files.RemoveAt(0);
                }
            }
            if (file != null)
            {
                Store(file);
                StoreByThead(files);
            }
            else
            {
                timer1.Enabled = false;
                writeText(textResult, true, "全部执行完成!");
            }
        }


        private void BackupMany(string path, List<string> dbNames, bool backupdata, string theadname)
        {
            string name = null;
            lock (lockobject)
            {
                if (dbNames.Count > 0)
                {
                    name = dbNames[0];
                    dbNames.RemoveAt(0);
                }
            }
            if (name != null)
            {
                writeText(txtErr, true, theadname + "开始库" + name + Environment.NewLine);
                Backup(path, name, backupdata);
                BackupMany(path, dbNames, backupdata, theadname);
            }

        }

        int h = 0;
        int m = 0;
        int s = 0;
        private void clearTime()
        {
            h = 0;
            m = 0;
            s = 0;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            s++;
            if (s == 60)
            {
                s = 0;
                m++;
                if (m == 60)
                {
                    h++;
                    m = 0;
                }

            }
            UseTime.Text = h + ":" + m + ":" + s;
        }



        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.password = txtpassword.Text.Trim();

            Properties.Settings.Default.characterSet = txtcharacterSet.Text.Trim();
            Properties.Settings.Default.host = txthost.Text.Trim();
            Properties.Settings.Default.password = txtpassword.Text.Trim();
            Properties.Settings.Default.port = txtport.Text.Trim();
            Properties.Settings.Default.user = txtuser.Text.Trim();
            Properties.Settings.Default.savePath = txtSavePath.Text.Trim();

            Properties.Settings.Default.Save();
        }


    }
}
